//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

//
// Handling incoming connections (up or downloadrequests)
//

#ifndef CLIENTTCPSOCKET_H
#define CLIENTTCPSOCKET_H

#include "Types.h"		// Needed for uint8_t, uint16_t, uint32_t and wxULongLong
#include "EMSocket.h"		// Needed for CEMSocket

#include <wx/dynarray.h>


//------------------------------------------------------------------------------
// CClientTCPSocket
//------------------------------------------------------------------------------

WX_DECLARE_OBJARRAY(wxString, ArrayOfwxStrings);

class CUpDownClient;
class CPacket;
class CTimerWnd;

class CClientTCPSocket : public CEMSocket
{
//	DECLARE_DYNAMIC_CLASS(CClientTCPSocket)
public:
	CClientTCPSocket(CUpDownClient* in_client = NULL);
	~CClientTCPSocket();
	
    virtual bool Destroy() ;

	void		Disconnect(const wxString& strReason);

	void		ResetTimeOutTimer();
	bool		CheckTimeOut();

	void		Safe_Delete();

	bool		deletethis; // 0.30c (Creteil), set as bool

	void		OnConnect(int nErrorCode);
	void		OnSend(int nErrorCode);
	void		OnReceive(int nErrorCode);
	
	void		OnClose(int nErrorCode);
	void		OnError(int nErrorCode);
	
	uint32_t		timeout_timer;

	void		SetClient(CUpDownClient* client);
	CUpDownClient* GetClient() { return m_client; }
	
	virtual void SendPacket(CPacket* packet, bool delpacket = true, bool controlpacket = true, uint32_t actualPayloadSize = 0);
    virtual SocketSentBytes SendControlData(uint32_t maxNumberOfBytesToSend, uint32_t overchargeMaxBytesToSend);
    virtual SocketSentBytes SendFileAndControlData(uint32_t maxNumberOfBytesToSend, uint32_t overchargeMaxBytesToSend);

protected:
	virtual bool PacketReceived(CPacket* packet);

private:
	CUpDownClient*	m_client;

//	void	Delete_Timed();
	bool	ProcessPacket(CPacket * packet); //const char *packet, uint32_t size, uint8_t opcode);
	bool	ProcessExtPacket(CPacket * packet); //const char *packet, uint32_t size, uint8_t opcode);
	bool	IsMessageFiltered(const wxString& Message, CUpDownClient* client);
	
	wxString encodeDirName(wxString dirName);
	ArrayOfwxStrings getListofSharedFolders();
};

#endif // CLIENTTCPSOCKET_H
