//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#ifndef COLORFRAMECTRL_H
#define COLORFRAMECTRL_H

#include <wx/brush.h>		// Needed for wxBrush
#include <wx/control.h>		// Needed for wxControl

//#include "Types.h"		// Needed for RECT
#include "wx/colour.h"		// Needed for wxColour


/////////////////////////////////////////////////////////////////////////////
// CColorFrameCtrl window

class CColorFrameCtrl : public wxControl {

public:
	CColorFrameCtrl( wxWindow* parent, int id,int wid,int hei );

	void SetFrameColor(wxColour color);
	void SetBackgroundColor(wxColour color);

	wxColour m_crBackColor;        // background color
	wxColour m_crFrameColor;       // frame color

	virtual ~CColorFrameCtrl();

protected:

	void OnPaint(wxPaintEvent& evt);
	void OnSize(wxSizeEvent& evt);

	wxRect  m_rectClient;
	wxBrush m_brushBack,m_brushFrame;

	DECLARE_EVENT_TABLE()

};

/////////////////////////////////////////////////////////////////////////////

#endif // COLORFRAMECTRL_H
