//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#ifndef FRIENDLIST_H
#define FRIENDLIST_H

#include <list>

#include "Types.h"	// Needed for uint32_t

#include "i2p/CI2PAddress.h"

class wxString;
class CFriend;
class CUpDownClient;
class CMD4Hash;

typedef std::list<CFriend*> FriendList;

class CFriendList 
{
public:
	CFriendList();
	~CFriendList();
	
	//I2P:bool		IsAlreadyFriend( uint32_t dwLastUsedIP, uint32_t nLastUsedPort );
	bool		IsAlreadyFriend( const CI2PAddress & nLastUsedDest );  
	void		SaveList();
	void		LoadList();
	// I2P : replaced all IP,PORT by DEST
	CFriend*	FindFriend( const CMD4Hash& userhash, const CI2PAddress &nDest);	
	void 		AddFriend(CFriend* toadd);
	void		AddFriend( CUpDownClient* toadd );
	void		AddFriend( const CMD4Hash& userhash, uint32_t lastSeen,
				   const CI2PAddress &lastUsedDest, uint32_t lastChatted,
       				   const wxString& name);
	void		RemoveFriend( const CMD4Hash& userhash, const CI2PAddress &lastUsedDest);
	void		RequestSharedFileList(const CMD4Hash& userhash, const CI2PAddress &nDest);
	void		UpdateFriendName(const CMD4Hash& userhash, const wxString& name, const CI2PAddress &nDest);

	void		SetFriendSlot(const CMD4Hash& userhash, const CI2PAddress &nDest, bool new_state);
	void		StartChatSession(const CMD4Hash& userhash, const CI2PAddress &nDest);
	void		RemoveAllFriendSlots();

//private:

	//TODO #warning THIS MUST BE MADE PRIVATE AFTER EC IS CODED
	FriendList m_FriendList;
};

#endif
