//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#ifndef FRIENDLISTCTRL_H
#define FRIENDLISTCTRL_H

#include "MuleListCtrl.h"
#include "MD4Hash.h"

#include "i2p/CI2PAddress.h"

class wxString;
class CUpDownClient;

class CDlgFriend {
public:
	//CDlgFriend(const CMD4Hash& hash, const wxString& name, uint32_t ip, uint16_t port, bool IsLinked, bool HasFriendSlot);
	CDlgFriend(const CMD4Hash& hash, const wxString& name, const CI2PAddress & dest, bool IsLinked, bool HasFriendSlot);

	wxString m_name;
	/*I2P:
	uint32_t m_ip;
	uint16_t m_port;*/
	CI2PAddress m_dest;
	
	CMD4Hash	m_hash;
	bool islinked;
	bool hasfriendslot;
};

class CFriendListCtrl : public CMuleListCtrl
{
public:
	CFriendListCtrl(wxWindow* parent, int id, const wxPoint& pos, wxSize siz, int flags);
	~CFriendListCtrl();
	
	//bool		IsAlreadyFriend( uint32_t dwLastUsedIP, uint32_t nLastUsedPort ); 
	void		LoadList();
	bool		IsAlreadyFriend( const CI2PAddress & dwLastUsedDest ); 
	
	//CDlgFriend*	FindFriend( const CMD4Hash& userhash, uint32_t dwIP, uint16_t nPort);	
	CDlgFriend*	FindFriend( const CMD4Hash& userhash, const CI2PAddress & dwDest );	
	
	void 		AddFriend(CDlgFriend* toadd, bool send_to_core = true);
	void		AddFriend( CUpDownClient* toadd );
	//void		AddFriend( const CMD4Hash& userhash, const wxString& name, uint32_t lastUsedIP, uint32_t lastUsedPort, bool IsLinked = false, bool HasFriendSlot = false, bool send_to_core = true);
	void		AddFriend( const CMD4Hash& userhash, const wxString& name, const CI2PAddress & lastUsedDest, bool IsLinked = false, bool HasFriendSlot = false, bool send_to_core = true);
	
	void		RemoveFriend(CDlgFriend* todel);
	void		RemoveFriend(CUpDownClient* todel);
	void		RefreshFriend(CDlgFriend* toupdate);
	//void		SetLinked(const CMD4Hash& userhash, uint32_t dwIP, uint16_t nPort, bool new_state);
	void		SetLinked(const CMD4Hash& userhash, const CI2PAddress & dwDest, bool new_state);
	
protected:
	DECLARE_EVENT_TABLE()

	void	OnRightClick(wxMouseEvent& event);
		
private:
	void	OnItemActivated(wxListEvent& event);

	// Menu Items
	void	OnShowDetails(wxCommandEvent& event);
	void	OnSendMessage(wxCommandEvent& event);
	void	OnRemoveFriend(wxCommandEvent& event);
	void	OnSetFriendslot(wxCommandEvent& event);
	void	OnAddFriend(wxCommandEvent& event);
	void	OnViewFiles(wxCommandEvent& event);
	void	OnKeyPressed(wxKeyEvent& event);
};

#endif
