//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2004-2006 Angel Vidal (Kry) ( kry@amule.org / http://www.imule.i2p )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#ifndef KADDLG_H
#define KADDLG_H

#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
    #pragma interface "KadDlg.cpp"
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include "muuli_wdr.h"

#include "Types.h"
#include "GuiEvents.h"

class COScopeCtrl;  
class wxListEvent;
class wxCommandEvent;
class wxMouseEvent;
class KadNodesListView;
typedef struct UpdateInfo GraphUpdateInfo;
    

class CKadDlg : public wxPanel
{
public:
    CKadDlg(wxWindow* pParent, const int & id = -1, const wxPoint = wxDefaultPosition, 
		wxSize size=wxDefaultSize, int opt=wxTAB_TRAVERSAL );
    ~CKadDlg() {};

    void Init();
    void SetUpdatePeriod(int step);
    void SetGraphColors();
    void UpdateGraph(bool bStatsVisible, const GraphUpdateInfo& update);
    void OnNodeEvent(const GUIEvent & evt);

private:
    COScopeCtrl      * m_kad_scope ;
    KadNodesListView * m_nodes_list;
    wxStaticBoxSizer * m_nodes_box;

    // Event handlers
    void        OnBnClickedCopyMyDestToClipboard(wxCommandEvent& evt);
    void        OnBnClickedBootstrapClient(wxCommandEvent& evt);
    void        OnBnClickedBootstrapKnown(wxCommandEvent& evt);
    void        OnBnClickedDisconnectKad(wxCommandEvent& evt);
    void        OnBnClickedUpdateNodeList(wxCommandEvent& evt);
    void        OnFieldsChange(wxCommandEvent& evt);
    void        OnBnClickedNodeExport(wxCommandEvent& evt);
    
    // WDR: method declarations for CKadDlg
    KadNodesListView* GetListctrl()  { return (KadNodesListView*) FindWindow( ID_KadDlgNodesList ); }
    COScopeCtrl* GetKadscope()  { return (COScopeCtrl*) FindWindow( ID_KADSCOPE ); }

    DECLARE_EVENT_TABLE()
};

#endif // KADDLG_H
