//
// This file is part of the imule Project.
//
// Copyright (c) 2004-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#include <wx/mstream.h>
#include <wx/gifdecod.h>
#include <wx/window.h>
#include <wx/dcbuffer.h>

#include "MuleGifCtrl.h"

MuleGifCtrl::MuleGifCtrl ( wxWindow *parent, wxWindowID id, const wxPoint& pos,
                           const wxSize& size, long style, const wxValidator& validator,
                           const wxString& name )
    : wxAnimationCtrl ( parent, id, wxNullAnimation, pos, size, style, name )
{}

MuleGifCtrl::~MuleGifCtrl()
{
    if (IsPlaying())
	Stop();
}

bool MuleGifCtrl::LoadData ( const char* data, int size )
{
	wxImage frame;
	wxMemoryInputStream stream ( data, size );

	if ( m_decoder.Load( stream, wxANIMATION_TYPE_GIF ) != true )
	{
		return false;
	}
	
	SetAnimation(m_decoder);
	return true;
}


void MuleGifCtrl::Start()

{
	Play();
}


void MuleGifCtrl::Stop()
{
	wxAnimationCtrl::Stop();
}


wxSize MuleGifCtrl::GetBestSize()
{
	return GetAnimation().GetSize();
}
