//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#include <wx/wx.h>
#include "OPCodes.h"

// event types
DEFINE_EVENT_TYPE(LISTENSOCKET_HANDLER);
DEFINE_EVENT_TYPE(CLIENTTCPSOCKET_HANDLER);
DEFINE_EVENT_TYPE(SERVERUDPSOCKET_HANDLER);
DEFINE_EVENT_TYPE(SERVERSOCKET_HANDLER);
DEFINE_EVENT_TYPE(CLIENTUDPSOCKET_HANDLER);
DEFINE_EVENT_TYPE(PROXY_SOCKET_HANDLER);
DEFINE_EVENT_TYPE(ID_CORETIMER);
DEFINE_EVENT_TYPE(ID_GUITIMER);
DEFINE_EVENT_TYPE(TM_DNSDONE);
DEFINE_EVENT_TYPE(TM_SOURCESDNSDONE);
DEFINE_EVENT_TYPE(TM_TCPSOCKET);
DEFINE_EVENT_TYPE(TM_UDPSOCKET);

// MOD Note: Do not change this part - Merkur
uint32_t MAX_RESULTS					= 100 ; 			// max global search results
uint32_t MAX_CLIENTCONNECTIONTRY	= 2 ;

//TODO #warning shorten for testing
uint32_t MIN_REQUESTTIME				= 0 ;        // 590000 =  MIN2MS(10) - SEC2MS(10) // clients requesting files more often will gain agressiveness, then be banned

//TODO #warning shorten for testing
uint32_t FILEREASKTIME					= MIN2MS ( 10 );	// 20mn before retrying to connect to a client for a downloading file
//, 1 minute less to contact him on his udp port if we already are on his queue but not connected.

uint32_t CONNECTION_TIMEOUT			= MIN2MS ( 10 )  ; 	/* 10mn. Sockets unused during this time are disconnected.
														(20mn if it participates in a chat session !)
														set this lower if you want less connections at once,
														set  it higher if you have enough sockets (edonkey has its own timout too,
														so a very high value won't effect this) */

//TODO #warning shorten for testing
uint32_t DOWNLOADTIMEOUT				= MIN2MS ( 11 ) ;  // (10mn) send "cancel transfer" if no download has COME for this time
// and consider myself on the other client's queue

uint32_t SERVERREASKTIME				= MIN2MS ( 15 );   // don't set this too low, it wont speed up anything, but it could kill imule or your internetconnection
uint32_t UDPSERVERREASKTIME			= MIN2MS ( 25 ) ; 	// 1300000 <- original value ***
uint32_t SOURCECLIENTREASKS			= MIN2MS ( 40 ) ; 	//40 mins
uint32_t SOURCECLIENTREASKF			= MIN2MS ( 5 ) ; 	//5 mins
uint32_t KADEMLIAASKTIME				= SEC2MS ( 1 ) ; 	//1 second
uint32_t KADEMLIATOTALFILE		        	= 7 ; 			//Total files to search sources for.
uint32_t KADEMLIAREASKTIME			= HR2MS ( 1 ) ; 	//1 hour
uint32_t KADEMLIAPUBLISHTIME			= SEC ( 2 ) ; 		//2 second
uint32_t KADEMLIATOTALSTORENOTES	= 1 ; 			//Total hashes to store.
uint32_t KADEMLIATOTALSTORESRC		= 2 ; 			//Total hashes to store.
uint32_t KADEMLIATOTALSTOREKEY		= 1 ; 			//Total hashes to store.

//TODO #warning shorten for testing

uint32_t KADEMLIAREPUBLISHTIMES			= HR2S ( 5 ) ;          //5 hours // delay before republishing sources
uint32_t KADEMLIAREPUBLISHTIMEN			= HR2S ( 24 ) ; 	//24 hours // delay before republishing notes
uint32_t KADEMLIAREPUBLISHTIMEK			= HR2S ( 24 ) ;         //24 hours // delay before republishing keywords
uint32_t KADEMLIADISCONNECTDELAY		= MIN2S ( 20 ) ; 	//20 mins
uint32_t KADEMLIAMAXINDEX			= 50000 ; 		//Total keyword indexes.
uint32_t KADEMLIAMAXENTRIES			= 60000 ; 		//Total keyword entries.
uint32_t KADEMLIAMAXSOUCEPERFILE		= 300 ; 		//Max number of sources per file in index.
uint32_t KADEMLIAMAXNOTESPERFILE		= 50 ; 			//Max number of notes per entry in index.

uint32_t ED2KREPUBLISHTIME			= MIN2MS ( 1 ) ; 	//1 min
uint32_t MINCOMMONPENALTY			= 4 ;
uint32_t UDPSERVERSTATTIME			= SEC2MS ( 5 ) ; 	//5 secs
uint32_t UDPSERVSTATREASKTIME			= HR2MS ( 4 ) ; 	//4 hours - eMule uses HR2S, we are based on GetTickCount, hence MS
uint32_t UDPSERVERPORT				= 4665 ; 		//default udp port
uint32_t UDPMAXQUEUETIME			= SEC2MS ( 30 ) ; 	//30 Seconds
uint32_t RSAKEYSIZE				= 384 ; 		//384 bits
uint32_t MAX_SOURCES_FILE_SOFT			= 500 ;
uint32_t MAX_SOURCES_FILE_UDP			= 50 ;
double SESSIONMAXTRANS			= ( 9.3*1024*1024 ) ;   // 9.3 Mbytes. "Try to send complete chunks" always sends this amount of data
uint32_t SESSIONMAXTIME				= HR2MS ( 1 ) ; 	//1 hour
uint32_t MAXFILECOMMENTLEN			= 50 ;
uint32_t MIN_UP_CLIENTS_ALLOWED			= 2 ; 	                /* min. clients allowed to download regardless UPLOAD_CLIENT_DATARATE
                                                                   or any other factors. Don't set this too high */
// MOD Note: end

uint32_t MAXCONPER5SEC				= 20 ;
uint32_t MAXCON5WIN9X				= 10 ;
uint32_t UPLOAD_CHECK_CLIENT_DR			= 1000 ;     // not used
uint32_t UPLOAD_LOW_CLIENT_DR			= 2400 ;     /* not used - uploadspeed per client in bytes - you may want to adjust
							        this if you have a slow connection or T1-T3 ;) */
uint32_t UPLOAD_CLIENT_DATARATE			= 3072 ;     // min. client datarate. Used to compute the max. number of downloading peers
uint32_t MAX_UP_CLIENTS_ALLOWED			= 250 ;      // max. clients allowed regardless UPLOAD_CLIENT_DATARATE or any other factors. Don't set this too low, use DATARATE to adjust uploadspeed per client
uint32_t CONSERVTIMEOUT				= 120000 ;   // (2mn) agelimit for pending connection attempts towards ED2K server
uint32_t RARE_FILE				= 50 ;
uint32_t BADCLIENTBAN				= 4 ;        // not used

uint32_t MAX_PURGEQUEUETIME			= 3600000 ;
uint32_t PURGESOURCESWAPSTOP			= 900000 ;   // (15 mins), how long forbid swapping a source to a certain file (NNP,...)

//TODO #warning longed for testing
uint32_t CONNECTION_LATENCY			= MIN2MS ( 2 ); // (2mn) // 22050	// latency for responses

uint32_t SOURCESSLOTS				= 100 ;
uint32_t MINWAIT_BEFORE_DLDISPLAY_WINDOWUPDATE	= 1500 ;
uint32_t MAXAVERAGETIME				= 40000 ;    // millisecs

//TODO #warning shorten for testing
uint32_t CLIENTBANTIME				= MIN2MS ( 1 ) ; // 1mn (7200000 // 2h)

uint32_t TRACKED_CLEANUP_TIME			= HR2MS ( 1 )  ; // 1 hour
uint32_t KEEPTRACK_TIME				= HR2MS ( 2 )  ; // 2h	//how long to keep track of clients which were once in the uploadqueue
uint32_t CLIENTLIST_CLEANUP_TIME		= MIN2MS ( 34 ); // 34 min






wxString opstr ( int prot, int op )
{
	switch ( prot )
	{
		case OP_EDONKEYHEADER :
		case OP_EDONKEYPROT :
		case OP_PACKEDPROT :
		case OP_EMULEPROT :
		case OP_MLDONKEYPROT :
			return opstr ( op );

		case OP_KADEMLIAHEADER :
		case OP_KADEMLIAPACKEDPROT :
			return kadopstr ( op );

		default:
			return wxT ( "unknown" );
	}
}

wxString kadopstr ( int op )
{
	switch ( op )
	{
		KADEMLIA_BOOTSTRAP_REQ : return wxT ( "KADEMLIA_BOOTSTRAP_REQ" );
		KADEMLIA_BOOTSTRAP_RES : return wxT ( "KADEMLIA_BOOTSTRAP_RES" );

		KADEMLIA_HELLO_REQ : return wxT ( "KADEMLIA_HELLO_REQ" );
		KADEMLIA_HELLO_RES : return wxT ( "KADEMLIA_HELLO_RES" );

		KADEMLIA_REQ : return wxT ( "KADEMLIA_REQ" );
		KADEMLIA_RES : return wxT ( "KADEMLIA_RES" );

		KADEMLIA_SEARCH_REQ : return wxT ( "KADEMLIA_SEARCH_REQ" );
		KADEMLIA_SEARCH_RES : return wxT ( "KADEMLIA_SEARCH_RES" );

		KADEMLIA_SRC_NOTES_REQ : return wxT ( "KADEMLIA_SRC_NOTES_REQ" );

		KADEMLIA_PUBLISH_REQ : return wxT ( "KADEMLIA_PUBLISH_REQ" );
		KADEMLIA_PUBLISH_RES : return wxT ( "KADEMLIA_PUBLISH_RES" );

		KADEMLIA_PUB_NOTES_REQ : return wxT ( "KADEMLIA_PUB_NOTES_REQ" );


		KADEMLIA_FIND_NODE : return wxT ( "KADEMLIA_FIND_NODE" );
		KADEMLIA_FIND_VALUE : return wxT ( "KADEMLIA_FIND_VALUE" );
		KADEMLIA_STORE : return wxT ( "KADEMLIA_STORE" );

		default : return wxT("unknown");
	}
}

wxString opstr ( int op )
{
	switch ( op )
	{
		case OP_EDONKEYHEADER : return wxT ( "OP_EDONKEYHEADER" );

		case OP_EDONKEYPROT : return wxT ( "OP_EDONKEYPROT" );

		case OP_PACKEDPROT : return wxT ( "OP_PACKEDPROT" );

		case OP_EMULEPROT : return wxT ( "OP_EMULEPROT" );

		case OP_KADEMLIAHEADER : return wxT ( "OP_KADEMLIAHEADER" );

		case OP_KADEMLIAPACKEDPROT : return wxT ( "OP_KADEMLIAPACKEDPROT" );

		case OP_MLDONKEYPROT : return wxT ( "OP_MLDONKEYPROT" );

		case OP_LOGINREQUEST : return wxT ( "OP_LOGINREQUEST" );

		case OP_REJECT : return wxT ( "OP_REJECT" );

		case OP_GETSERVERLIST : return wxT ( "OP_GETSERVERLIST" );

		case OP_OFFERFILES : return wxT ( "OP_OFFERFILES" );

		case OP_SEARCHREQUEST : return wxT ( "OP_SEARCHREQUEST" );

		case OP_DISCONNECT : return wxT ( "OP_DISCONNECT" );

		case OP_GETSOURCES : return wxT ( "OP_GETSOURCES" );

		case OP_SEARCH_USER : return wxT ( "OP_SEARCH_USER" );

		case OP_CALLBACKREQUEST : return wxT ( "OP_CALLBACKREQUEST" );

		case OP_QUERY_MORE_RESULT : return wxT ( "OP_QUERY_MORE_RESULT" );

		case OP_SERVERLIST : return wxT ( "OP_SERVERLIST" );

		case OP_SEARCHRESULT : return wxT ( "OP_SEARCHRESULT" );

		case OP_SERVERSTATUS : return wxT ( "OP_SERVERSTATUS" );

		case OP_CALLBACKREQUESTED : return wxT ( "OP_CALLBACKREQUESTED" );

		case OP_CALLBACK_FAIL : return wxT ( "OP_CALLBACK_FAIL" );

		case OP_SERVERMESSAGE : return wxT ( "OP_SERVERMESSAGE" );

		case OP_IDCHANGE : return wxT ( "OP_IDCHANGE" );

		case OP_SERVERIDENT : return wxT ( "OP_SERVERIDENT" );

		case OP_FOUNDSOURCES : return wxT ( "OP_FOUNDSOURCES" );

		case OP_USERS_LIST : return wxT ( "OP_USERS_LIST" );

		case OP_GLOBGETSOURCES2 : return wxT ( "OP_GLOBGETSOURCES2" );

		case OP_GLOBSERVSTATREQ : return wxT ( "OP_GLOBSERVSTATREQ" );

		case OP_GLOBSERVSTATRES : return wxT ( "OP_GLOBSERVSTATRES" );

		case OP_GLOBSEARCHREQ : return wxT ( "OP_GLOBSEARCHREQ" );

		case OP_GLOBSEARCHRES : return wxT ( "OP_GLOBSEARCHRES" );

		case OP_GLOBGETSOURCES : return wxT ( "OP_GLOBGETSOURCES" );

		case OP_GLOBFOUNDSOURCES : return wxT ( "OP_GLOBFOUNDSOURCES" );

		case OP_GLOBCALLBACKREQ : return wxT ( "OP_GLOBCALLBACKREQ" );

		case OP_SERVER_LIST_REQ : return wxT ( "OP_SERVER_LIST_REQ" );

		case OP_SERVER_LIST_RES : return wxT ( "OP_SERVER_LIST_RES" );

		case OP_SERVER_DESC_REQ : return wxT ( "OP_SERVER_DESC_REQ" );

		case OP_SERVER_DESC_RES : return wxT ( "OP_SERVER_DESC_RES" );

		case OP_SERVER_LIST_REQ2 : return wxT ( "OP_SERVER_LIST_REQ2" );

		case INV_SERV_DESC_LEN : return wxT ( "INV_SERV_DESC_LEN" );

		case OP_HELLO : return wxT ( "OP_HELLO" );

		case OP_SENDINGPART : return wxT ( "OP_SENDINGPART" );

		case OP_REQUESTPARTS : return wxT ( "OP_REQUESTPARTS" );

		case OP_FILEREQANSNOFIL : return wxT ( "OP_FILEREQANSNOFIL" );

		case OP_END_OF_DOWNLOAD : return wxT ( "OP_END_OF_DOWNLOAD" );

		case OP_ASKSHAREDFILES : return wxT ( "OP_ASKSHAREDFILES" );

		case OP_ASKSHAREDFILESANSWER : return wxT ( "OP_ASKSHAREDFILESANSWER" );

		case OP_HELLOANSWER : return wxT ( "OP_HELLOANSWER" );

		case OP_CHANGE_CLIENT_ID : return wxT ( "OP_CHANGE_CLIENT_ID" );

		case OP_MESSAGE : return wxT ( "OP_MESSAGE" );

		case OP_SETREQFILEID : return wxT ( "OP_SETREQFILEID" );

		case OP_FILESTATUS : return wxT ( "OP_FILESTATUS" );

		case OP_HASHSETREQUEST : return wxT ( "OP_HASHSETREQUEST" );

		case OP_HASHSETANSWER : return wxT ( "OP_HASHSETANSWER" );

		case OP_STARTUPLOADREQ : return wxT ( "OP_STARTUPLOADREQ" );

		case OP_ACCEPTUPLOADREQ : return wxT ( "OP_ACCEPTUPLOADREQ" );

		case OP_CANCELTRANSFER : return wxT ( "OP_CANCELTRANSFER" );

		case OP_OUTOFPARTREQS : return wxT ( "OP_OUTOFPARTREQS" );

		case OP_REQUESTFILENAME : return wxT ( "OP_REQUESTFILENAME" );

		case OP_REQFILENAMEANSWER : return wxT ( "OP_REQFILENAMEANSWER" );

		case OP_CHANGE_SLOT : return wxT ( "OP_CHANGE_SLOT" );

		case OP_QUEUERANK : return wxT ( "OP_QUEUERANK" );

		case OP_ASKSHAREDDIRS : return wxT ( "OP_ASKSHAREDDIRS" );

		case OP_ASKSHAREDFILESDIR : return wxT ( "OP_ASKSHAREDFILESDIR" );

		case OP_ASKSHAREDDIRSANS : return wxT ( "OP_ASKSHAREDDIRSANS" );

		case OP_ASKSHAREDFILESDIRANS : return wxT ( "OP_ASKSHAREDFILESDIRANS" );

		case OP_ASKSHAREDDENIEDANS : return wxT ( "OP_ASKSHAREDDENIEDANS" );

		case OP_EMULEINFO : return wxT ( "OP_EMULEINFO" );

		case OP_EMULEINFOANSWER : return wxT ( "OP_EMULEINFOANSWER" );

		case OP_COMPRESSEDPART : return wxT ( "OP_COMPRESSEDPART" );

		case OP_QUEUERANKING : return wxT ( "OP_QUEUERANKING" );

		case OP_FILEDESC : return wxT ( "OP_FILEDESC" );

		case OP_VERIFYUPSREQ : return wxT ( "OP_VERIFYUPSREQ" );

		case OP_VERIFYUPSANSWER : return wxT ( "OP_VERIFYUPSANSWER" );

		case OP_UDPVERIFYUPREQ : return wxT ( "OP_UDPVERIFYUPREQ" );

		case OP_UDPVERIFYUPA : return wxT ( "OP_UDPVERIFYUPA" );

		case OP_REQUESTSOURCES : return wxT ( "OP_REQUESTSOURCES" );

		case OP_ANSWERSOURCES : return wxT ( "OP_ANSWERSOURCES" );

		case OP_PUBLICKEY : return wxT ( "OP_PUBLICKEY" );

		case OP_SIGNATURE : return wxT ( "OP_SIGNATURE" );

		case OP_SECIDENTSTATE : return wxT ( "OP_SECIDENTSTATE" );

		case OP_REQUESTPREVIEW : return wxT ( "OP_REQUESTPREVIEW" );

		case OP_PREVIEWANSWER : return wxT ( "OP_PREVIEWANSWER" );

		case OP_MULTIPACKET : return wxT ( "OP_MULTIPACKET" );

		case OP_MULTIPACKETANSWER : return wxT ( "OP_MULTIPACKETANSWER" );

		case OP_PEERCACHE_QUERY : return wxT ( "OP_PEERCACHE_QUERY" );

		case OP_PEERCACHE_ANSWER : return wxT ( "OP_PEERCACHE_ANSWER" );

		case OP_PEERCACHE_ACK : return wxT ( "OP_PEERCACHE_ACK" );

		case OP_PUBLICIP_REQ : return wxT ( "OP_PUBLICIP_REQ" );

		case OP_PUBLICIP_ANSWER : return wxT ( "OP_PUBLICIP_ANSWER" );

		case OP_CALLBACK : return wxT ( "OP_CALLBACK" );

		case OP_AICHREQUEST : return wxT ( "OP_AICHREQUEST" );

		case OP_AICHANSWER : return wxT ( "OP_AICHANSWER" );

		case OP_AICHFILEHASHANS : return wxT ( "OP_AICHFILEHASHANS" );

		case OP_AICHFILEHASHREQ : return wxT ( "OP_AICHFILEHASHREQ" );

		case OP_REASKFILEPING : return wxT ( "OP_REASKFILEPING" );

		case OP_REASKACK : return wxT ( "OP_REASKACK" );

		case OP_FILENOTFOUND : return wxT ( "OP_FILENOTFOUND" );

		case OP_QUEUEFULL : return wxT ( "OP_QUEUEFULL" );

		case OP_PORTTEST : return wxT ( "OP_PORTTEST" );

		default:
			return wxString ( wxT ( "unknown(" ) ) << op << wxT ( ")" ) ;
	}
}



wxString tagnameStr ( int tag )
{
	switch ( tag )
	{
		case ST_SERVERNAME : return wxT ( "ST_SERVERNAME" );

		case ST_DESCRIPTION : return wxT ( "ST_DESCRIPTION" );

		case ST_PING : return wxT ( "ST_PING" );

		case ST_PREFERENCE : return wxT ( "ST_PREFERENCE" );

		case ST_FAIL : return wxT ( "ST_FAIL" );

		case ST_USERS : return wxT ( "ST_USERS" );

		case ST_FILES : return wxT ( "ST_FILES" );

		case ST_DYNIP : return wxT ( "ST_DYNIP" );

		case ST_LASTPING : return wxT ( "ST_LASTPING" );

		case ST_MAXUSERS : return wxT ( "ST_MAXUSERS" );

		case ST_SOFTFILES : return wxT ( "ST_SOFTFILES" );

		case ST_HARDFILES : return wxT ( "ST_HARDFILES" );

		case ST_VERSION : return wxT ( "ST_VERSION" );

		case ST_UDPFLAGS : return wxT ( "ST_UDPFLAGS" );

		case ST_AUXPORTSLIST : return wxT ( "ST_AUXPORTSLIST" );



		case CT_NAME : return wxT ( "CT_NAME" );

		case CT_VERSION : return wxT ( "CT_VERSION" );

		case CT_SERVER_FLAGS : return wxT ( "CT_SERVER_FLAGS" );

		case CT_EMULECOMPAT_OPTIONS : return wxT ( "CT_EMULECOMPAT_OPTIONS" );

		case CT_EMULE_MISCOPTIONS1 : return wxT ( "CT_EMULE_MISCOPTIONS1" );

		case CT_EMULE_VERSION : return wxT ( "CT_EMULE_VERSION" );

		case CT_DEST : return wxT ( "CT_DEST" );

		case CT_EMULE_MISCOPTIONS2 : return wxT ( "CT_EMULE_MISCOPTIONS2" );



		case ET_COMPRESSION : return wxT ( "ET_COMPRESSION" );

		case ET_UDPDEST : return wxT ( "ET_UDPDEST" );

		case ET_UDPVER : return wxT ( "ET_UDPVER" );

		case ET_SOURCEEXCHANGE : return wxT ( "ET_SOURCEEXCHANGE" );

		case ET_COMMENTS : return wxT ( "ET_COMMENTS" );

		case ET_EXTENDEDREQUEST : return wxT ( "ET_EXTENDEDREQUEST" );

		case ET_COMPATIBLECLIENT : return wxT ( "ET_COMPATIBLECLIENT" );

		case ET_FEATURES : return wxT ( "ET_FEATURES" );

		case ET_MOD_VERSION : return wxT ( "ET_MOD_VERSION" );

		case ET_FEATURESET : return wxT ( "ET_FEATURESET" );

		case ET_OS_INFO : return wxT ( "ET_OS_INFO" );



		case TAG_FILENAME : return wxT ( "TAG_FILENAME" );

		case TAG_FILESIZE : return wxT ( "TAG_FILESIZE" );

		case TAG_FILETYPE : return wxT ( "TAG_FILETYPE" );

		case TAG_FILEFORMAT : return wxT ( "TAG_FILEFORMAT" );

		case TAG_LASTSEENCOMPLETE : return wxT ( "TAG_LASTSEENCOMPLETE" );

		case TAG_PART_PATH : return wxT ( "TAG_PART_PATH" );

		case TAG_PART_HASH : return wxT ( "TAG_PART_HASH" );

		case TAG_TRANSFERED : return wxT ( "TAG_TRANSFERED" );

		case TAG_GAP_START : return wxT ( "TAG_GAP_START" );

		case TAG_GAP_END : return wxT ( "TAG_GAP_END" );

		case TAG_DESCRIPTION : return wxT ( "TAG_DESCRIPTION" );

		case TAG_PING : return wxT ( "TAG_PING" );

		case TAG_FAIL : return wxT ( "TAG_FAIL" );

		case TAG_PREFERENCE : return wxT ( "TAG_PREFERENCE" );

		case TAG_VERSION : return wxT ( "TAG_VERSION" );

		case TAG_PARTFILENAME : return wxT ( "TAG_PARTFILENAME" );

		case TAG_PRIORITY : return wxT ( "TAG_PRIORITY" );

		case TAG_STATUS : return wxT ( "TAG_STATUS" );

		case TAG_SOURCES : return wxT ( "TAG_SOURCES" );

		case TAG_QTIME : return wxT ( "TAG_QTIME" );

		case TAG_PARTS : return wxT ( "TAG_PARTS" );

		case TAG_DLPRIORITY : return wxT ( "TAG_DLPRIORITY" );

		case TAG_ULPRIORITY : return wxT ( "TAG_ULPRIORITY" );

		case TAG_KADLASTPUBLISHKEY : return wxT ( "TAG_KADLASTPUBLISHKEY" );

		case TAG_KADLASTPUBLISHSRC : return wxT ( "TAG_KADLASTPUBLISHSRC" );

		case TAG_FLAGS : return wxT ( "TAG_FLAGS" );

		case TAG_DL_ACTIVE_TIME : return wxT ( "TAG_DL_ACTIVE_TIME" );

		case TAG_CORRUPTEDPARTS : return wxT ( "TAG_CORRUPTEDPARTS" );

		case TAG_DL_PREVIEW : return wxT ( "TAG_DL_PREVIEW" );

		case TAG_KADLASTPUBLISHNOTES : return wxT ( "TAG_KADLASTPUBLISHNOTES" );

		case TAG_AICH_HASH : return wxT ( "TAG_AICH_HASH" );

		case TAG_COMPLETE_SOURCES : return wxT ( "TAG_COMPLETE_SOURCES" );

		case TAG_COLLECTION : return wxT ( "TAG_COLLECTION" );

		case TAG_PERMISSIONS : return wxT ( "TAG_PERMISSIONS" );

		case TAG_ATTRANSFERED : return wxT ( "TAG_ATTRANSFERED" );

		case TAG_ATREQUESTED : return wxT ( "TAG_ATREQUESTED" );

		case TAG_ATACCEPTED : return wxT ( "TAG_ATACCEPTED" );

		case TAG_CATEGORY : return wxT ( "TAG_CATEGORY" );

		case TAG_MEDIA_ARTIST : return wxT ( "TAG_MEDIA_ARTIST" );

		case TAG_MEDIA_ALBUM : return wxT ( "TAG_MEDIA_ALBUM" );

		case TAG_MEDIA_TITLE : return wxT ( "TAG_MEDIA_TITLE" );

		case TAG_MEDIA_LENGTH : return wxT ( "TAG_MEDIA_LENGTH" );

		case TAG_MEDIA_BITRATE : return wxT ( "TAG_MEDIA_BITRATE" );

		case TAG_MEDIA_CODEC : return wxT ( "TAG_MEDIA_CODEC" );

		case TAG_FILERATING : return wxT ( "TAG_FILERATING" );

		case TAG_SERVERDEST : return wxT ( "TAG_SERVERDEST" );

		case TAG_SOURCEUDEST : return wxT ( "TAG_SOURCEUDEST" );

		case TAG_SOURCEDEST : return wxT ( "TAG_SOURCEDEST" );

		case TAG_SOURCETYPE : return wxT ( "TAG_SOURCETYPE" );



		default : return wxT ( "Unknown" );
	}
}


wxString tagtypeStr ( int tag )
{
	switch ( tag )
	{
		case TAGTYPE_INVALID : return wxT ( "TAGTYPE_INVALID" );

		case TAGTYPE_HASH : return wxT ( "TAGTYPE_HASH" );

		case TAGTYPE_STRING : return wxT ( "TAGTYPE_STRING" );

		case TAGTYPE_FLOAT32 : return wxT ( "TAGTYPE_FLOAT32" );

		case TAGTYPE_BOOL : return wxT ( "TAGTYPE_BOOL" );

		case TAGTYPE_BOOLARRAY : return wxT ( "TAGTYPE_BOOLARRAY" );

		case TAGTYPE_BLOB : return wxT ( "TAGTYPE_BLOB" );

		case TAGTYPE_UINT64 : return wxT ( "TAGTYPE_UINT64" );

		case TAGTYPE_UINT32 : return wxT ( "TAGTYPE_UINT32" );

		case TAGTYPE_UINT16 : return wxT ( "TAGTYPE_UINT16" );

		case TAGTYPE_UINT8 : return wxT ( "TAGTYPE_UINT8" );

		case TAGTYPE_BSOB : return wxT ( "TAGTYPE_BSOB" );

		case TAGTYPE_STR1 : return wxT ( "TAGTYPE_STR1" );

		case TAGTYPE_STR2 : return wxT ( "TAGTYPE_STR2" );

		case TAGTYPE_STR3 : return wxT ( "TAGTYPE_STR3" );

		case TAGTYPE_STR4 : return wxT ( "TAGTYPE_STR4" );

		case TAGTYPE_STR5 : return wxT ( "TAGTYPE_STR5" );

		case TAGTYPE_STR6 : return wxT ( "TAGTYPE_STR6" );

		case TAGTYPE_STR7 : return wxT ( "TAGTYPE_STR7" );

		case TAGTYPE_STR8 : return wxT ( "TAGTYPE_STR8" );

		case TAGTYPE_STR9 : return wxT ( "TAGTYPE_STR9" );

		case TAGTYPE_STR10 : return wxT ( "TAGTYPE_STR10" );

		case TAGTYPE_STR11 : return wxT ( "TAGTYPE_STR11" );

		case TAGTYPE_STR12 : return wxT ( "TAGTYPE_STR12" );

		case TAGTYPE_STR13 : return wxT ( "TAGTYPE_STR13" );

		case TAGTYPE_STR14 : return wxT ( "TAGTYPE_STR14" );

		case TAGTYPE_STR15 : return wxT ( "TAGTYPE_STR15" );

		case TAGTYPE_STR16 : return wxT ( "TAGTYPE_STR16" );

		case TAGTYPE_STR17 : return wxT ( "TAGTYPE_STR17" );

		case TAGTYPE_STR18 : return wxT ( "TAGTYPE_STR18" );

		case TAGTYPE_STR19 : return wxT ( "TAGTYPE_STR19" );

		case TAGTYPE_STR20 : return wxT ( "TAGTYPE_STR20" );

		case TAGTYPE_STR21 : return wxT ( "TAGTYPE_STR21" );

		case TAGTYPE_STR22 : return wxT ( "TAGTYPE_STR22" );

		case TAGTYPE_ADDRESS : return wxT ( "TAGTYPE_ADDRESS" );

		case TAGTYPE_UINT64UINT64 : return wxT ( "TAGTYPE_UINT64UINT64" );

		default : return wxT ( "Unknown" );
	}
}
