//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#ifndef OPCODES_H
#define OPCODES_H

#define	SEC2MS(sec)		((sec)*1000)
#define	MIN2MS(min)		SEC2MS((min)*60)
#define	HR2MS(hr)		MIN2MS((hr)*60)
#define	DAY2MS(day)		HR2MS((day)*24)
#define	SEC(sec)		(sec)
#define	MIN2S(min)		((min)*60)
#define	HR2S(hr)		MIN2S((hr)*60)
#define	DAY2S(day)		HR2S((day)*24)

#include <wx/event.h>

#include <inttypes.h>

// Handlers

DECLARE_EVENT_TYPE(LISTENSOCKET_HANDLER,);
DECLARE_EVENT_TYPE(CLIENTTCPSOCKET_HANDLER,);
DECLARE_EVENT_TYPE(SERVERUDPSOCKET_HANDLER,);
DECLARE_EVENT_TYPE(SERVERSOCKET_HANDLER,);
DECLARE_EVENT_TYPE(CLIENTUDPSOCKET_HANDLER,);
DECLARE_EVENT_TYPE(PROXY_SOCKET_HANDLER,);
DECLARE_EVENT_TYPE(ID_CORETIMER,);
DECLARE_EVENT_TYPE(ID_GUITIMER,);
DECLARE_EVENT_TYPE(TM_DNSDONE,);
DECLARE_EVENT_TYPE(TM_SOURCESDNSDONE,);
DECLARE_EVENT_TYPE(TM_TCPSOCKET,);
DECLARE_EVENT_TYPE(TM_UDPSOCKET,);


// MOD Note: Do not change this part - Merkur
#define	CURRENT_VERSION_SHORT			0x44
#define	EMULE_PROTOCOL				0x01
// MOD Note: end

// imule version

// No more Mod Version unless we're cvs

// RELEASERS: REMOVE THE DEFINE ON THE RELEASES, PLEASE
// AND FIX THE MOD_VERSION_LONG

//#define __CVS__

#ifdef __CVS__
#define	MOD_VERSION_LONG		wxT("iMule CVS")
#else
#define	MOD_VERSION_LONG		wxT("iMule 1.0.0")
#endif

#define	VERSION_MJR     1
#define	VERSION_MIN     0
#define	VERSION_UPDATE  0

#define	EDONKEYVERSION				0x3c
#define	PREFFILE_VERSION			0x14 //<<-- last change: reduced .dat, by using .ini
#define	PARTFILE_VERSION			0xe0
#define	PARTFILE_SPLITTEDVERSION		0xe1 // For edonkey part files importing.
#define	CREDITFILE_VERSION			0x12

#define COMPILE_DATE				__DATE__
#define COMPILE_TIME				__TIME__

enum EClientSoftware {
    SO_CDONKEY			= 1,
    SO_LXMULE			= 2,
    SO_EMULE			= 3,
    SO_SHAREAZA			= 4,
    SO_EMULEPLUS		= 5,
    SO_HYDRANODE		= 6,
    SO_IMULE			= 7,
    SO_NEW2_MLDONKEY		= 0x0a,
    SO_LPHANT			= 0x14,
    SO_NEW2_SHAREAZA		= 0x28,
    SO_EDONKEYHYBRID		= 0x32,
    SO_EDONKEY			= 0x33,
    SO_MLDONKEY			= 0x34,
    SO_OLDEMULE			= 0x35,
    SO_UNKNOWN			= 0x36,
    SO_NEW_SHAREAZA			= 0x44,
    SO_NEW_MLDONKEY			= 0x98,
    SO_COMPAT_UNK			= 0xFF
};

// Numeric constants, defined in OPCodes.cpp

extern wxUint32 MAX_RESULTS			 ;

extern wxUint32 MAX_CLIENTCONNECTIONTRY		 ;

extern wxUint32 CONNECTION_TIMEOUT		 ;

extern wxUint32 FILEREASKTIME			 ;

extern wxUint32 SERVERREASKTIME			 ;

extern wxUint32 UDPSERVERREASKTIME		 ;

extern wxUint32 SOURCECLIENTREASKS		 ;

extern wxUint32 SOURCECLIENTREASKF		 ;

extern wxUint32 KADEMLIAASKTIME			 ;

extern wxUint32 KADEMLIATOTALFILE		 ;

extern wxUint32 KADEMLIAREASKTIME		 ;

extern wxUint32 KADEMLIAPUBLISHTIME		 ;

extern wxUint32 KADEMLIATOTALSTORENOTES		 ;

extern wxUint32 KADEMLIATOTALSTORESRC		 ;

extern wxUint32 KADEMLIATOTALSTOREKEY		 ;

extern wxUint32 KADEMLIAREPUBLISHTIMES		 ;

extern wxUint32 KADEMLIAREPUBLISHTIMEN		 ;

extern wxUint32 KADEMLIAREPUBLISHTIMEK		 ;

extern wxUint32 KADEMLIADISCONNECTDELAY		 ;

extern wxUint32 KADEMLIAMAXINDEX		 ;

extern wxUint32 KADEMLIAMAXENTRIES		 ;

extern wxUint32 KADEMLIAMAXSOUCEPERFILE		 ;

extern wxUint32 KADEMLIAMAXNOTESPERFILE		 ;

extern wxUint32 ED2KREPUBLISHTIME		 ;

extern wxUint32 MINCOMMONPENALTY		 ;

extern wxUint32 UDPSERVERSTATTIME		 ;

extern wxUint32 UDPSERVSTATREASKTIME		 ;

extern wxUint32 UDPSERVERPORT			 ;

extern wxUint32 UDPMAXQUEUETIME			 ;

extern wxUint32 RSAKEYSIZE			 ;

extern wxUint32 MAX_SOURCES_FILE_SOFT		 ;

extern wxUint32 MAX_SOURCES_FILE_UDP		 ;

extern double   SESSIONMAXTRANS			 ;

extern wxUint32 SESSIONMAXTIME			 ;

extern wxUint32 MAXFILECOMMENTLEN		 ;

extern wxUint32 MIN_UP_CLIENTS_ALLOWED		 ;

extern wxUint32 MAXCONPER5SEC			 ;

extern wxUint32 MAXCON5WIN9X			 ;

extern wxUint32 UPLOAD_CHECK_CLIENT_DR		 ;

extern wxUint32 UPLOAD_LOW_CLIENT_DR		 ;

extern wxUint32 UPLOAD_CLIENT_DATARATE		 ;

extern wxUint32 MAX_UP_CLIENTS_ALLOWED		 ;

extern wxUint32 DOWNLOADTIMEOUT			 ;

extern wxUint32 CONSERVTIMEOUT			 ;

extern wxUint32 RARE_FILE			 ;

extern wxUint32 BADCLIENTBAN			 ;

extern wxUint32 MIN_REQUESTTIME			 ;

extern wxUint32 MAX_PURGEQUEUETIME		 ;

extern wxUint32 PURGESOURCESWAPSTOP		 ;

extern wxUint32 CONNECTION_LATENCY		 ;

extern wxUint32 SOURCESSLOTS			 ;

extern wxUint32 MINWAIT_BEFORE_DLDISPLAY_WINDOWUPDATE	 ;

extern wxUint32 MAXAVERAGETIME			 ;

extern wxUint32 CLIENTBANTIME			 ;

extern wxUint32 TRACKED_CLEANUP_TIME		 ;

extern wxUint32 KEEPTRACK_TIME			 ;

extern wxUint32 CLIENTLIST_CLEANUP_TIME	         ;


// you shouldn't change anything here if you are not really sure, or imule will probaly not work

enum FileConstants
{
	MAX_FILE_SIZE	= 18446744073706496000llu    //(wxLL(0xFFFFFFFFFFFFFFFF)/PARTSIZE)*PARTSIZE
};
enum FilePartsConstants
{
	PARTSIZE	= 9728000u,
	BLOCKSIZE	= 184320u,
	EMBLOCKSIZE	= 184320u
};

#define	MAXFRAGSIZE				1300
#define	MET_HEADER				0x0E

const unsigned UNLIMITED = 0;

wxString opstr ( int prot );
wxString kadopstr ( int op );
wxString opstr ( int prot, int op );

// Known protocols
enum Protocols
{
    OP_EDONKEYHEADER = 1,
    OP_EDONKEYPROT,
    OP_PACKEDPROT,
    OP_EMULEPROT,
    OP_KADEMLIAHEADER,
    OP_KADEMLIAPACKEDPROT,
    OP_MLDONKEYPROT,
};


enum OP_Codes
{
    // OP-codes used with TCP server connctions.
    OP_LOGINREQUEST = 8,				// <HASH 16><ID 4><PORT 2><1 Tag_set>
    OP_REJECT,				// (null)
    OP_GETSERVERLIST,				// (null)client->server
    OP_OFFERFILES,				// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
    OP_SEARCHREQUEST,				// <Query_Tree>
    OP_DISCONNECT,				// (not verified)
    OP_GETSOURCES,				// <HASH 16> /v2 <HASH 16><SIZE_4> (17.3)
    OP_SEARCH_USER,				// <Query_Tree>
    OP_CALLBACKREQUEST,				// <ID 4>
    //OP_QUERY_CHATS,				// (deprecated not supported by server any longer)
    //OP_CHAT_MESSAGE,				// (deprecated not supported by server any longer)
    //OP_JOIN_ROOM,				// (deprecated not supported by server any longer)
    OP_QUERY_MORE_RESULT,				// (null)
    OP_SERVERLIST,				// <count 1>(<IP 4><PORT 2>)[count] server->client
    OP_SEARCHRESULT,				// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
    OP_SERVERSTATUS,				// <USER 4><FILES 4>
    OP_CALLBACKREQUESTED,				// <IP 4><PORT 2>
    OP_CALLBACK_FAIL,				// (null notverified)
    OP_SERVERMESSAGE,				// <len 2><Message len>
    //OP_CHAT_ROOM_REQUEST,				// (deprecated not supported by server any longer)
    //OP_CHAT_BROADCAST,				// (deprecated not supported by server any longer)
    //OP_CHAT_USER_JOIN,				// (deprecated not supported by server any longer)
    //OP_CHAT_USER_LEAVE,				// (deprecated not supported by server any longer)
    //OP_CHAT_USER,				// (deprecated not supported by server any longer)
    OP_IDCHANGE,				// <NEW_ID 4>
    OP_SERVERIDENT,				// <HASH 16><IP 4><PORT 2>{1 TAG_SET}
    OP_FOUNDSOURCES,				// <HASH 16><count 1>(<ID 4><PORT 2>)[count]
    OP_USERS_LIST,				// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]


    //client <-> UDP server
    OP_GLOBGETSOURCES2,				// <HASH 16><SIZE_4>*
    OP_GLOBSERVSTATREQ,				// (null)
    OP_GLOBSERVSTATRES,				// <USER 4><FILES 4>
    OP_GLOBSEARCHREQ,				// <search_tree>
    OP_GLOBSEARCHRES,				//
    OP_GLOBGETSOURCES,				// <HASH 16>
    OP_GLOBFOUNDSOURCES,				//
    OP_GLOBCALLBACKREQ,				// <IP 4><PORT 2><client_ID 4>
    //OP_INVALID_LOWID,				// <ID 4>
    OP_SERVER_LIST_REQ,				// <IP 4><PORT 2>
    OP_SERVER_LIST_RES,				// <count 1> (<ip 4><port 2>)[count]
    OP_SERVER_DESC_REQ,				// (null)
    OP_SERVER_DESC_RES,				// <name_len 2><name name_len><desc_len 2 desc_en>
    OP_SERVER_LIST_REQ2,				// (null)
#define INV_SERV_DESC_LEN			0xF0FF	// used as an 'invalid' string len for OP_SERVER_DESC_REQ/RES

    // client <-> client
    OP_HELLO,				// 0x10<HASH 16><ID 4><PORT 2><1 Tag_set>
    OP_SENDINGPART,				// <HASH 16><von 4><bis 4><Daten len:(von-bis)>
    OP_REQUESTPARTS,				// <HASH 16><von[3] 4*3><bis[3] 4*3>
    OP_FILEREQANSNOFIL,				// <HASH 16>
    OP_END_OF_DOWNLOAD,				// <HASH 16>
    OP_ASKSHAREDFILES,				// (null)
    OP_ASKSHAREDFILESANSWER,				// <count 4>(<HASH 16><ID 4><PORT 2><1 Tag_set>)[count]
    OP_HELLOANSWER,				// <HASH 16><ID 4><PORT 2><1 Tag_set><SERVER_IP 4><SERVER_PORT 2>
    OP_CHANGE_CLIENT_ID,				// <ID_old 4><ID_new 4>
    OP_MESSAGE,				// <len 2><Message len>
    OP_SETREQFILEID,				// <HASH 16>
    OP_FILESTATUS,				// <HASH 16><count 2><status(bit array) len:((count+7)/8)>
    OP_HASHSETREQUEST,				// <HASH 16>
    OP_HASHSETANSWER,				// <count 2><HASH[count] 16*count>
    OP_STARTUPLOADREQ,				// <HASH 16>
    OP_ACCEPTUPLOADREQ,				// (null)
    OP_CANCELTRANSFER,				// (null)
    OP_OUTOFPARTREQS,				// (null)
    OP_REQUESTFILENAME,				// <HASH 16>	(more correctly file_name_request)
    OP_REQFILENAMEANSWER,				// <HASH 16><len 4><NAME len>
    OP_CHANGE_SLOT,				// <HASH 16>
    OP_QUEUERANK,				// <wert  4> (slot index of the request)
    OP_ASKSHAREDDIRS,				// (null)
    OP_ASKSHAREDFILESDIR,				// <len 2><Directory len>
    OP_ASKSHAREDDIRSANS,				// <count 4>(<len 2><Directory len>)[count]
    OP_ASKSHAREDFILESDIRANS,				// <len 2><Directory len><count 4>(<HASH 16><ID 4><PORT 2><1 T
    OP_ASKSHAREDDENIEDANS,				// (null)

    // this 'identifier' is used for referencing shared part (incomplete) files with the OP_ASKSHAREDDIRS and related opcodes
    // it was introduced with eDonkeyHybrid and is considered as part of the protocol.
#define OP_INCOMPLETE_SHARED_FILES wxT("!Incomplete Files")

    // extened prot client <-> extened prot client
    OP_EMULEINFO,				//
    OP_EMULEINFOANSWER,				//
    OP_COMPRESSEDPART,				//
    OP_QUEUERANKING,				// <RANG 2>
    OP_FILEDESC,				// <len 2><NAME len>
    OP_VERIFYUPSREQ,				// (never used)
    OP_VERIFYUPSANSWER,				// (never used)
    OP_UDPVERIFYUPREQ,				// (never used)
    OP_UDPVERIFYUPA,				// (never used)
    OP_REQUESTSOURCES,				// <HASH 16>
    OP_ANSWERSOURCES,				//
    OP_PUBLICKEY,				// <len 1><pubkey len>
    OP_SIGNATURE,				// v1: <len 1><signature len>
    // v2: <len 1><signature len><sigIPused 1>
    OP_SECIDENTSTATE,				// <state 1><rndchallenge 4>
    OP_REQUESTPREVIEW,				// <HASH 16>
    OP_PREVIEWANSWER,				// <HASH 16><frames 1>{frames * <len 4><frame len>}
    OP_MULTIPACKET,
    OP_MULTIPACKETANSWER,
    OP_PEERCACHE_QUERY,
    OP_PEERCACHE_ANSWER,
    OP_PEERCACHE_ACK,
    OP_PUBLICIP_REQ,
    OP_PUBLICIP_ANSWER,
    OP_CALLBACK,				// <HASH 16><HASH 16><uint 16>
    //OP_REASKCALLBACKTCP,
    OP_AICHREQUEST,				// <HASH 16><uint16_t><HASH aichhashlen>
    OP_AICHANSWER,				// <HASH 16><uint16_t><HASH aichhashlen> <data>
    OP_AICHFILEHASHANS,
    OP_AICHFILEHASHREQ,
    //OP_BUDDYPING,
    //OP_BUDDYPONG,

    // extened prot client <-> extened prot client UDP
    OP_REASKFILEPING,				// <HASH 16>
    OP_REASKACK,				// <RANG 2>
    OP_FILENOTFOUND,				// (null)
    OP_QUEUEFULL,				// (null)
    //OP_REASKCALLBACKUDP,
    OP_PORTTEST					// Connection Test
};



enum KAD_Opcodes
{
    // KADEMLIA (opcodes) (udp)
    KADEMLIA_BOOTSTRAP_REQ = 1,		// <PEER (sender) [25]>
    KADEMLIA_BOOTSTRAP_RES,		// <CNT [2]> <PEER [25]>*(CNT)

    KADEMLIA_HELLO_REQ,	 		// <PEER (sender) [25]>
    KADEMLIA_HELLO_RES,     		// <PEER (receiver) [25]>

    KADEMLIA_REQ,		   		// <TYPE [1]> <HASH (target) [16]> <HASH (receiver) 16>
    KADEMLIA_RES,				// <HASH (target) [16]> <CNT> <PEER [25]>*(CNT)

    KADEMLIA_SEARCH_REQ,			// <HASH (key) [16]> <ext 0/1 [1]> <SEARCH_TREE>[ext]
    KADEMLIA_SEARCH_RES,			// <HASH (key) [16]> <CNT1 [2]> (<HASH (answer) [16]> <CNT2 [2]> <META>*(CNT2))*(CNT1)

    KADEMLIA_SRC_NOTES_REQ,		// <HASH (key) [16]>

    KADEMLIA_PUBLISH_REQ,		// <HASH (key) [16]> <CNT1 [2]> (<HASH (target) [16]> <CNT2 [2]> <META>*(CNT2))*(CNT1)
    KADEMLIA_PUBLISH_RES,		// <HASH (key) [16]>

    KADEMLIA_PUB_NOTES_REQ,		// <HASH (key) [16]> <HASH (target) [16]> <CNT2 [2]> <META>*(CNT2))*(CNT1)
};

/*/////////////////////////////////////////////////////////////////////////////// 
66	 	// Mr Hyde: rimossa per KADU2 (copiato da aMule 3.15b74) 
67	 	// // ADUNANZA BEGIN 
68	 	// #if 0 
69	 	// #define      KADEMLIA_FIND_VALUE             0x02 
70	 	// #define      KADEMLIA_STORE                  0x04 
71	 	// #define      KADEMLIA_FIND_NODE              0x0B 
72	 	// #endif 
73	 	#define KADEMLIA_FIND_VALUE             0x08 
74	 	#define KADEMLIA_STORE                  0x06 
75	 	#define KADEMLIA_FIND_NODE              0x38 
76	 	// // ADUNANZA END 
 	66	#define KADEMLIA_FIND_VALUE             0x02 
 	67	#define KADEMLIA_STORE                  0x04 
 	68	#define KADEMLIA_FIND_NODE              0x0B */
enum KAD_Params
{
    // KADEMLIA (parameter)
    KADEMLIA_FIND_VALUE =   2,
    KADEMLIA_STORE      =   4,
    KADEMLIA_FIND_NODE  =  11,
};


wxString tagnameStr ( int tag );

enum TAG_Codes
{

    // server.met
    ST_SERVERNAME = 1,   // <string>
    ST_DESCRIPTION,      // <string>
    ST_PING,						// <uint32_t>
    ST_PREFERENCE,					// <uint32_t>
    ST_FAIL,						// <uint32_t>
    ST_USERS,			            // <uint32_t>
    ST_FILES,				    // <uint32_t>
    ST_DYNIP,
    ST_LASTPING,					// <uint32_t>
    ST_MAXUSERS,
    ST_SOFTFILES,
    ST_HARDFILES,
    ST_VERSION,					// <string>
    ST_UDPFLAGS,					// <uint32_t>
    ST_AUXPORTSLIST,					// <string>

	// client info tags
	CT_NAME,
	CT_VERSION,
	CT_SERVER_FLAGS,				// currently only used to inform a server about supported features
	CT_EMULECOMPAT_OPTIONS,
	CT_EMULE_MISCOPTIONS1,
	CT_EMULE_VERSION,
	CT_DEST,
	CT_EMULE_MISCOPTIONS2,

	// *Mule tagnames
	ET_COMPRESSION					,
	ET_UDPDEST						,
	ET_UDPVER						,
	ET_SOURCEEXCHANGE				,
	ET_COMMENTS						,
	ET_EXTENDEDREQUEST				,
	ET_COMPATIBLECLIENT				,
	ET_FEATURES						,		//! bit 0: SecIdent v1 - bit 1: SecIdent v2
	ET_MOD_VERSION					,
	ET_FEATURESET					    ,	// int - [Bloodymad Featureset]
	ET_OS_INFO						,		// Reused rand tag (MOD_OXY), because the type is unknown
	
		
    //file tags
    TAG_FILENAME,		            // <string>
    TAG_FILESIZE,				 	// <uint32_t>
    TAG_FILETYPE,				 	// <string>
    TAG_FILEFORMAT,				 	// <string>
    TAG_LASTSEENCOMPLETE,			 	// <uint32_t>
    TAG_PART_PATH,				 	// <string>
    TAG_PART_HASH,
    TAG_TRANSFERED,				 	// <uint32_t>
    TAG_GAP_START,				 	// <uint32_t>
    TAG_GAP_END,				 	// <uint32_t>
    TAG_DESCRIPTION,				 	// <string>
    TAG_PING,
    TAG_FAIL,
    TAG_PREFERENCE,
    TAG_VERSION,				 	// <string>
    TAG_PARTFILENAME,			 	// <string>
    TAG_PRIORITY,				 	// <uint32_t>
    TAG_STATUS,				 	// <uint32_t>
    TAG_SOURCES,				 	// <uint32_t>
    TAG_QTIME,
    TAG_PARTS,
    TAG_DLPRIORITY,				 	// Was 13
    TAG_ULPRIORITY,				 	// Was 17
    TAG_KADLASTPUBLISHKEY,			 	// <uint32_t>
    TAG_KADLASTPUBLISHSRC,			 	// <uint32_t>
    TAG_FLAGS,				 	    // <uint32_t>
#define TAG_FLAGS_COMPLETEFILE 0x01
    TAG_DL_ACTIVE_TIME,			 	// <uint32_t>
    TAG_CORRUPTEDPARTS,			 	// <string>
    TAG_DL_PREVIEW,
    TAG_KADLASTPUBLISHNOTES,	                 	// <uint32_t>
    TAG_AICH_HASH,
    TAG_COMPLETE_SOURCES,			// nr. of sources which share a complete version
    //of the associated file (supported by eserver 16.46+)
    TAG_COLLECTION,
    TAG_PERMISSIONS,

    // statistic
    TAG_ATTRANSFERED,			 	// <wxULongLong>
    TAG_ATREQUESTED,			 	// <uint32_t>
    TAG_ATACCEPTED,			 	// <uint32_t>
    TAG_CATEGORY,			 	// <uint32_t>
    TAG_ATTRANSFEREDHI,		 	// <uint32_t> not used anymore
    TAG_MEDIA_ARTIST,		 	// <string>
    TAG_MEDIA_ALBUM,			 	// <string>
    TAG_MEDIA_TITLE,			 	// <string>
    TAG_MEDIA_LENGTH,		 	// <uint32_t> !!!
    TAG_MEDIA_BITRATE,		 	// <uint32_t>
    TAG_MEDIA_CODEC,			 	// <string>
    TAG_FILERATING,			 	// <uint8_t>

    TAG_SERVERDEST,			 	// <CI2PAddress>
    TAG_SOURCEUDEST,			 	// <CI2PAddress>
    TAG_SOURCEDEST,			 	// <CI2PAddress>
    TAG_SOURCETYPE			 	// <uint8_t>
};

wxString tagtypeStr ( int tag );

#define	TAGTYPE_INVALID			0x00
#define	TAGTYPE_HASH			0x01
#define	TAGTYPE_STRING			0x02
#define	TAGTYPE_UINT32			0x03
#define	TAGTYPE_FLOAT32			0x04
#define	TAGTYPE_BOOL			0x05
#define	TAGTYPE_BOOLARRAY		0x06
#define	TAGTYPE_BLOB			0x07
#define	TAGTYPE_UINT16			0x08
#define	TAGTYPE_UINT8			0x09
#define	TAGTYPE_BSOB			0x0A

#define TAGTYPE_STR1			0x11
#define TAGTYPE_STR2			0x12
#define TAGTYPE_STR3			0x13
#define TAGTYPE_STR4			0x14
#define TAGTYPE_STR5			0x15
#define TAGTYPE_STR6			0x16
#define TAGTYPE_STR7			0x17
#define TAGTYPE_STR8			0x18
#define TAGTYPE_STR9			0x19
#define TAGTYPE_STR10			0x1A
#define TAGTYPE_STR11			0x1B
#define TAGTYPE_STR12			0x1C
#define TAGTYPE_STR13			0x1D
#define TAGTYPE_STR14			0x1E
#define TAGTYPE_STR15			0x1F
#define TAGTYPE_STR16			0x20
#define TAGTYPE_STR17			0x21	// accepted by eMule 0.42f (02-Mai-2004) in receiving code
// only because of a flaw, those tags are handled correctly,
// but should not be handled at all
#define TAGTYPE_STR18			0x22	// accepted by eMule 0.42f (02-Mai-2004) in receiving code
//  only because of a flaw, those tags are handled correctly,
// but should not be handled at all
#define TAGTYPE_STR19			0x23	// accepted by eMule 0.42f (02-Mai-2004) in receiving code
// only because of a flaw, those tags are handled correctly,
// but should not be handled at all
#define TAGTYPE_STR20			0x24	// accepted by eMule 0.42f (02-Mai-2004) in receiving code
// only because of a flaw, those tags are handled correctly,
// but should not be handled at all
#define TAGTYPE_STR21			0x25	// accepted by eMule 0.42f (02-Mai-2004) in receiving code
// only because of a flaw, those tags are handled correctly,
// but should not be handled at all
#define TAGTYPE_STR22			0x26	// accepted by eMule 0.42f (02-Mai-2004) in receiving code
// only because of a flaw, those tags are handled correctly,
// but should not be handled at all
#define TAGTYPE_ADDRESS			0x27	// CI2PAddress
#define TAGTYPE_UINT64UINT64            0x28    // pair wxULongLong, wxULongLong
#define TAGTYPE_UINT64			0x29


#define	ED2KFTSTR_AUDIO			wxT("Audio")	// value for eD2K tag FT_FILETYPE
#define	ED2KFTSTR_VIDEO			wxT("Video")	// value for eD2K tag FT_FILETYPE
#define	ED2KFTSTR_IMAGE			wxT("Image")	// value for eD2K tag FT_FILETYPE
#define	ED2KFTSTR_DOCUMENT		wxT("Doc")	// value for eD2K tag FT_FILETYPE
#define	ED2KFTSTR_PROGRAM		wxT("Pro")	// value for eD2K tag FT_FILETYPE
#define	ED2KFTSTR_ARCHIVE		wxT("Arc")	// eMule internal use only
#define	ED2KFTSTR_CDIMAGE		wxT("Iso")	// eMule internal use only

// ed2k search expression comparison operators
#define ED2K_SEARCH_OP_EQUAL         0 // eserver 16.45+
#define ED2K_SEARCH_OP_GREATER       1 // dserver
#define ED2K_SEARCH_OP_LESS          2 // dserver
#define ED2K_SEARCH_OP_GREATER_EQUAL 3 // eserver 16.45+
#define ED2K_SEARCH_OP_LESS_EQUAL    4 // eserver 16.45+
#define ED2K_SEARCH_OP_NOTEQUAL      5 // eserver 16.45+

// Kad search expression comparison operators
#define KAD_SEARCH_OP_EQUAL         0 // eMule 0.43+
#define KAD_SEARCH_OP_GREATER_EQUAL 1 // eMule 0.40+; NOTE: this different than ED2K!
#define KAD_SEARCH_OP_LESS_EQUAL    2 // eMule 0.40+; NOTE: this different than ED2K!
#define KAD_SEARCH_OP_GREATER       3 // eMule 0.43+; NOTE: this different than ED2K!
#define KAD_SEARCH_OP_LESS          4 // eMule 0.43+; NOTE: this different than ED2K!
#define KAD_SEARCH_OP_NOTEQUAL      5 // eMule 0.43+


enum
{
    MP_MESSAGE = 11000, // Random start ID that doesn't conflict with wxDesigner
    MP_DETAIL,
    MP_ADDFRIEND,
    MP_REMOVEFRIEND,
    MP_SHOWLIST,
    MP_FRIENDSLOT,
    MP_CHANGE2FILE,
    MP_CANCEL,
    MP_STOP,
    MP_RESUME,
    MP_PAUSE,
    MP_CLEARCOMPLETED,
    MP_VIEW,
    MP_SENDMESSAGE,
    MP_WS,
    MP_RAZORSTATS,
    MP_GETCOMMENTS,
    //For comments
    MP_CMT,

    MP_PRIOVERYLOW,
    MP_PRIOLOW,
    MP_PRIONORMAL,
    MP_PRIOHIGH,
    MP_PRIOVERYHIGH,
    MP_POWERSHARE,
    MP_PRIOAUTO,
    MP_GETED2KLINK,
    MP_GETSOURCEED2KLINK,
    MP_GETHOSTNAMESOURCEED2KLINK,
    MP_GETAICHED2KLINK,
    MP_METINFO,
    MP_CONNECTTO,
    MP_REMOVE,
    MP_REMOVEALL,
    MP_UNBAN,
    MP_ADDTOSTATIC,
    MP_REMOVEFROMSTATIC,
    MP_VIEWFILECOMMENTS,
    MP_CAT_ADD,
    MP_CAT_EDIT,
    MP_CAT_REMOVE,
    MP_TOOGLELIST,
    MP_CLOSE_TAB,
    MP_CLOSE_ALL_TABS,
    MP_CLOSE_OTHER_TABS,
    MP_RENAME,

    /* Razor 1a - Modif by MikaelB
         Opcodes for :
          - Drop No Needed Sources now
          - Drop Full Queue Sources now
          - Drop High Queue Rating Sources now
          - Clean Up Sources now ( drop NNS, FQS and HQRS )
          - Swap every A4AF to this file now
          - Swap every A4AF to this file ( AUTO )
          - Swap every A4AF to any other file now   */
    MP_DROP_NO_NEEDED_SOURCES,
    MP_DROP_FULL_QUEUE_SOURCES,
    MP_DROP_HIGH_QUEUE_RATING_SOURCES,
    MP_CLEAN_UP_SOURCES,
    MP_SWAP_A4AF_TO_THIS,
    MP_SWAP_A4AF_TO_THIS_AUTO,
    MP_SWAP_A4AF_TO_ANY_OTHER,

    //menus
    MP_MENU_PRIO,
    MP_MENU_EXTD,
    MP_MENU_CATS,

    // CMuleListCtrl tabs.
    MP_LISTCOL_1,
    MP_LISTCOL_2,
    MP_LISTCOL_3,
    MP_LISTCOL_4,
    MP_LISTCOL_5,
    MP_LISTCOL_6,
    MP_LISTCOL_7,
    MP_LISTCOL_8,
    MP_LISTCOL_9,
    MP_LISTCOL_10,
    MP_LISTCOL_11,
    MP_LISTCOL_12,
    MP_LISTCOL_13,
    MP_LISTCOL_14,
    MP_LISTCOL_15,


    MP_ASSIGNCAT = 10800, // reserve some for categories!
    MP_CAT_SET0 = 10900, // reserve some for change all-cats (about 20)
    MP_SWITCHCTRL_0 = 10950,
    MP_SWITCHCTRL_9	= 10959,
};




#define	DISKSPACERECHECKTIME			60000	// checkDiskspace

#endif // OPCODES_H
