//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#ifndef OTHERSTRUCTS_H
#define OTHERSTRUCTS_H

#include "Types.h"		// Needed for uint8_t, uint32_t, uint8_t, uint16_t and uint32_t

#include "i2p/CI2PAddress.h"

// Defined in <zlib.h>
struct z_stream_s;

//			SERVER TO CLIENT
struct Header_Struct{
	uint8_t	eDonkeyID;
	uint32_t	packetlength;
	uint8_t	command;
} __attribute__((__packed__));

struct UDP_Header_Struct{
	uint8_t	eDonkeyID;
	uint8_t	command;
} __attribute__((__packed__));

struct Requested_Block_Struct{
	wxULongLong	StartOffset;
	wxULongLong	EndOffset;
	uint32_t	packedsize;
	unsigned char	FileID[16];
	uint32_t  transferred; // Barry - This counts bytes completed
} ;//__attribute__((__packed__));

struct Requested_File_Struct{
	unsigned char	  fileid[16];
	uint32_t	  lastasked;
	uint8_t	  badrequests;
} __attribute__((__packed__));

struct Pending_Block_Struct{
	Requested_Block_Struct*	block;
	struct z_stream_s*       zStream;       // Barry - Used to unzip packets
	uint32_t		totalUnzipped; // Barry - This holds the total unzipped bytes for all packets so far
	uint32_t		fZStreamError : 1,
				fRecovered    : 1;	
};

struct Gap_Struct{
	typedef wxULongLong pos_t;
	pos_t start;
	pos_t end;
};

struct ServerMet_Struct {
	/*uint32_t	ip;
	uint16_t	port;*/
	CI2PAddress dest;
	uint32_t	tagcount;
} /* __attribute__((__packed__))*/;

struct TransferredData {
	wxULongLong	datalen;
	uint32_t		timestamp;
};


//Kry import of 0.30d 
// Maella -Enhanced Chunk Selection- (based on jicxicmic)
struct Chunk {
	wxULongLong part;      // Index of the chunk
		union {
			uint16_t frequency; // Availability of the chunk
			uint16_t rank;      // Download priority factor (highest = 0, lowest = 0xffff)
	};
}; // TODO: __attribute__((__packed__));

enum DownloadItemType { FILE_TYPE, A4AF_SOURCE, UNAVAILABLE_SOURCE, AVAILABLE_SOURCE };

#endif // OTHERSTRUCTS_H
