//
// This file is part of the imule Project.
//
// Copyright (c) 2004-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2004-2006 Marcelo Jimenez ( phoenix@amule.org )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//


#include "Proxy.h"		/* for Interface		*/

//------------------------------------------------------------------------------
// CProxyData
//------------------------------------------------------------------------------

CProxyData::CProxyData()
{
	Clear();
}

CProxyData::CProxyData (
    bool		proxyEnable,
    CProxyType	proxyType,

    const wxString	&proxyHostName,
    unsigned short	proxyPort,
    bool		enablePassword,
    const wxString	&userName,
    const wxString	&password )
		:
		m_proxyEnable ( proxyEnable ),
		m_proxyType ( proxyType ),
		m_proxyHostName ( proxyHostName ),
		m_proxyPort ( proxyPort ),
		/*
		 * The flag m_enablePassword is currently not used. The first
		 * authentication method tryed is No-Authentication, the second
		 * is username/password. If there is no username/password in
		 * CProxyData, a NULL username/password is sent. That will probably
		 * lead to a failure, but at least we tryed. Maybe this behaviour
		 * could be altered later.
		 */
		m_enablePassword ( enablePassword ),
		m_userName ( userName ),
		m_password ( password )
{}

void CProxyData::Clear()

{
	m_proxyEnable = false;
	m_proxyType = PROXY_NONE;
	m_proxyHostName.Clear();
	m_proxyPort = 0;
	m_enablePassword = false;
	m_userName.Clear();
	m_password.Clear();
}


