//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

//
// Client to Server communication
//

#ifndef SERVERSOCKET_H
#define SERVERSOCKET_H

#include "Types.h"		// Needed for uint8_t and uint32_t
#include "EMSocket.h"		// Needed for CEMSocket
#include "ServerConnect.h"

//------------------------------------------------------------------------------
// CServerSocket
//------------------------------------------------------------------------------

class CServer;

class CServerSocket : public CEMSocket
{
//	DECLARE_DYNAMIC_CLASS(CServerSocket)
	friend class CServerConnect;
	CServerSocket() {};
	
public:
	CServerSocket(CServerConnect* in_serverconnect);
	virtual ~CServerSocket();

	void	ConnectToServer(CServer* server);
	int8_t	GetConnectionState()		{ return connectionstate; } 
 	uint32_t  GetLastTransmission() const	{ return m_dwLastTransmission; }
	wxString info;

	void	OnClose(wxSocketError nErrorCode);
	void	OnConnect(wxSocketError nErrorCode);
	void	OnReceive(wxSocketError nErrorCode);
	void	OnError(wxSocketError nErrorCode);
	bool	PacketReceived(CPacket* packet);
	void 	SendPacket(CPacket* packet, bool delpacket = true, bool controlpacket = true, uint32_t actualPayloadSize = 0);
	bool	IsSolving() const { return m_IsSolving;};
 	void	OnHostnameResolved(const CI2PAddress & dest/*uint32_t ip*/);
 	CServer *GetServerConnected() const { return serverconnect->GetCurrentServer(); }
	
private:
	bool	ProcessPacket(const char* packet, uint32_t size, uint8_t opcode);
	void	SetConnectionState(int8_t newstate);
	CServerConnect*	serverconnect; 
	int8_t	connectionstate;
	CServer*	cur_server;
	bool	headercomplete;
	uint32_t	sizetoget;
	uint32_t	sizereceived;
	char*	rbuffer;
	bool	m_bIsDeleting;	// true: socket is already in deletion phase, don't destroy it in ::StopConnectionTry
	uint32_t	m_dwLastTransmission;

	bool m_IsSolving;

};

#endif // SERVERSOCKET_H
