//
// This file is part of the imule Project.
//
// Copyright (c) 2003-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#ifndef SERVERUDPSOCKET_H
#define SERVERUDPSOCKET_H

#include "MuleUDPSocket.h"


class CPacket;
class CServer;
class CMemFile;


class CServerUDPSocket : public CMuleUDPSocket
{
public:
//I2P:	CServerUDPSocket(imuleIPV4Address& addr, const CProxyData* ProxyData = NULL);
	//CServerUDPSocket(wxIPV4address addr, wxString destKeyName, const CProxyData* ProxyData = NULL);
    CServerUDPSocket(wxString destKeyName, const CProxyData* ProxyData = NULL);

	void	SendPacket(CPacket* packet, CServer* host, bool delPacket);
	void	OnHostnameResolved(const CI2PAddress & dest); //uint32_t ip);

private:
	//I2P:void	OnPacketReceived(imuleIPV4Address& addr, uint8_t* buffer, size_t length);
	void	OnPacketReceived(const CI2PAddress & addr, uint8_t* buffer, size_t length);
	void	ProcessPacket(CMemFile& packet, uint8_t opcode, const CI2PAddress & host/*const wxString& host, uint16_t port*/);
	void	SendQueue();

	struct ServerUDPPacket {
		CPacket*	packet;
		/*uint32_t		ip;
		uint16_t		port;*/
		CI2PAddress		dest;
		wxString	addr;
	};

	typedef std::list<ServerUDPPacket> PacketList;
	PacketList m_queue;
};

#endif // SERVERUDPSOCKET_H
