//
// This file is part of the imule Project.
//
// Copyright (C) 2005-2006imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#ifndef THROTTLEDSOCKET_H
#define THROTTLEDSOCKET_H

#include "Types.h"
#include <wx/object.h>

struct SocketSentBytes
{
	bool    success;
	uint32_t	sentBytesStandardPackets;
	uint32_t	sentBytesControlPackets;
};



class ThrottledControlSocket : public wxObject
{
	public:
		virtual SocketSentBytes SendControlData ( uint32_t maxNumberOfBytesToSend, uint32_t minFragSize ) = 0;
};


class ThrottledFileSocket : public ThrottledControlSocket
{
	public:
		virtual SocketSentBytes SendFileAndControlData ( uint32_t maxNumberOfBytesToSend, uint32_t minFragSize ) = 0;
		virtual uint32_t GetLastCalledSend() = 0;
		virtual uint32_t	GetNeededBytes() = 0;
};

#endif
