#include <ctime>

#include "../utils/UInt128.h"

#include "Entry.h"

////////////////////////////////////////

namespace Kademlia
{
////////////////////////////////////////

	/*! A CEntry is an association between a key and a source
	* the source can be either a file (keyword entry) or a client (file entry)
	*/

	CEntry::CEntry()
	{
		/*ip = 0;
		tcpport = 0;
		udpport = 0;*/

		size = 0;
		lifetime = time ( NULL );
		source = false;
	}

	CEntry::~CEntry()
	{
	}

	wxULongLong CEntry::GetIntTagValue ( const uint8_t tagID ) const
	{
		TagList::const_iterator it;

		for ( it = taglist.begin(); it != taglist.end(); ++it )
		{
			const CTag & tag = *it;

			if ( tag . GetID() == tagID && tag . IsInt() )
			{
				return tag . GetInt();
			}
		}

		return 0;
	}

	wxString CEntry::GetStrTagValue ( const wxString& tagname ) const

	{
		TagList::const_iterator it;

		for ( it = taglist.begin(); it != taglist.end(); ++it )
		{
			const CTag & tag = *it;

			if ( tag . GetID() == tagname && tag . IsStr() )
			{
				return tag . GetStr();
			}
		}

		return wxEmptyString;
	}
}



