//
// This file is part of the imule Project.
//
// Copyright (c) 2004-2006 Angel Vidal (Kry) ( kry@amule.org )
// Copyright (c) 2004-2006 imule Team ( mkvore@mail.i2p / http://www.imule.i2p )
// Copyright (c) 2003 Barry Dunne (http://www.emule-project.net)
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

// Note To Mods //
/*
Please do not change anything here and release it..
There is going to be a new forum created just for the Kademlia side of the client..
If you feel there is an error or a way to improve something, please
post it in the forum first and let us look at it.. If it is a real improvement,
it will be added to the offical client.. Changing something without knowing
what all it does can cause great harm to the network if released in mass form..
Any mod that changes anything within the Kademlia side will not be allowed to advertise
there client on the eMule forum..
*/

#ifndef __PREFS_H__
#define __PREFS_H__

#include "../utils/UInt128.h"
#include "Types.h"
#include <ctime>

#include "i2p/CI2PAddress.h"

////////////////////////////////////////

namespace Kademlia
{
////////////////////////////////////////

	class CPrefs
	{
		private:
			CPrefs();
		
		public:
			~CPrefs();

			static  CPrefs * getInstance() ;

			void	setKadID ( const CUInt128 &id )		{m_clientID = id;}

			const	CUInt128& getKadID() const		{return m_clientID;}

			void	setClientHash ( const CUInt128 &id )	{m_clientHash = id;}

			const CUInt128& getClientHash() const		{return m_clientHash;}

			//uint32_t	getIPAddress() const				{return m_ip;}
			CI2PAddress	getDestAddress() const				{return m_dest;}

			//void	setIPAddress(uint32_t val);
			void	setDestAddress ( const CI2PAddress & val );

			bool	hasHadContact() const;

			void	setLastContact()					{m_lastContact = time ( NULL );}

			bool	hasLostConnection() const;

			time_t	getLastContact() const				{return m_lastContact;}

			uint8_t	getTotalFile() const				{return m_totalFile;}

			void	setTotalFile ( uint8_t val )				{m_totalFile = val;}

			uint8_t	getTotalStoreSrc() const			{return m_totalStoreSrc;}

			void	setTotalStoreSrc ( uint8_t val )			{m_totalStoreSrc = val;}

			uint8_t	getTotalStoreKey() const			{return m_totalStoreKey;}

			void	setTotalStoreKey ( uint8_t val )			{m_totalStoreKey = val;}

			uint8_t	getTotalSource() const				{return m_totalSource;}

			void	setTotalSource ( uint8_t val )			{m_totalSource = val;}

			uint8_t	getTotalNotes() const				{return m_totalNotes;}

			void	setTotalNotes ( uint8_t val )			{m_totalNotes = val;}

			uint8_t	getTotalStoreNotes() const			{return m_totalStoreNotes;}

			void	setTotalStoreNotes ( uint8_t val )		{m_totalStoreNotes = val;}

			uint32_t	getKademliaUsers() const			{return m_kademliaUsers;}

			void	setKademliaUsers ( uint32_t val )		{m_kademliaUsers = val;}

			uint32_t	getKademliaFiles() const			{return m_kademliaFiles;}

			void	setKademliaFiles();

			bool	getPublish() const					{return m_Publish;}

			void	setPublish ( bool val )				{m_Publish = val;}

		private:
			static CPrefs * instance ;
			wxString	m_filename;

			time_t		m_lastContact;
			CUInt128	m_clientID;
			CUInt128	m_clientHash;
			CI2PAddress	m_dest;
			CI2PAddress	m_destLast;

			uint32_t		m_kademliaUsers;
			uint32_t		m_kademliaFiles;
			uint8_t		m_totalFile;
			uint8_t		m_totalStoreSrc;
			uint8_t		m_totalStoreKey;
			uint8_t		m_totalSource;
			uint8_t		m_totalNotes;
			uint8_t		m_totalStoreNotes;
			bool		m_Publish;

			void init ( const wxString& filename );

			void reset();

			void setDefaults();

			void readFile();

			void writeFile();
	};

} // End namespace

#endif //__PREFS_H__
